# Generated by Django 5.1.6 on 2025-05-30 16:38

import wagtail.fields
from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        (
            "enap_designsystem",
            "0135_alter_areaaluno_body_alter_enapcomponentes_body_and_more",
        ),
    ]

    operations = [
        migrations.AlterField(
            model_name="templateespecializacao",
            name="content",
            field=wagtail.fields.StreamField(
                [("banner", 3)],
                blank=True,
                block_lookup={
                    0: (
                        "wagtail.images.blocks.ImageChooserBlock",
                        (),
                        {"label": "Background Image", "required": False},
                    ),
                    1: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Título do Banner",
                            "label": "Title",
                            "max_length": 255,
                            "required": True,
                        },
                    ),
                    2: (
                        "wagtail.blocks.RichTextBlock",
                        (),
                        {
                            "default": "Descrição do banner. Edite este texto para personalizar o conteúdo.",
                            "features": [
                                "bold",
                                "italic",
                                "ol",
                                "ul",
                                "hr",
                                "link",
                                "document-link",
                            ],
                            "label": "Description",
                            "required": True,
                        },
                    ),
                    3: (
                        "wagtail.blocks.StructBlock",
                        [[("background_image", 0), ("title", 1), ("description", 2)]],
                        {},
                    ),
                },
                default=[
                    (
                        "banner",
                        {
                            "background_image": None,
                            "description": "<p>Desenvolva suas competências e alcance novos patamares na sua carreira profissional com nossos programas de excelência.</p>",
                            "title": "MBA e Especialização",
                        },
                    )
                ],
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="templateespecializacao",
            name="feature_course",
            field=wagtail.fields.StreamField(
                [("feature_course", 5)],
                blank=True,
                block_lookup={
                    0: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Título da feature",
                            "help_text": "Primeiro título da feature",
                            "required": True,
                        },
                    ),
                    1: (
                        "wagtail.blocks.TextBlock",
                        (),
                        {
                            "default": "Descrição da feature",
                            "help_text": "Primeira descrição da feature",
                            "required": True,
                        },
                    ),
                    2: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Título da feature",
                            "help_text": "Segundo título da feature",
                            "required": True,
                        },
                    ),
                    3: (
                        "wagtail.blocks.TextBlock",
                        (),
                        {
                            "default": "Descrição da feature",
                            "help_text": "Segunda descrição da feature",
                            "required": True,
                        },
                    ),
                    4: (
                        "wagtail.images.blocks.ImageChooserBlock",
                        (),
                        {"help_text": "Imagem da feature do curso", "required": False},
                    ),
                    5: (
                        "wagtail.blocks.StructBlock",
                        [
                            [
                                ("title_1", 0),
                                ("description_1", 1),
                                ("title_2", 2),
                                ("description_2", 3),
                                ("image", 4),
                            ]
                        ],
                        {},
                    ),
                },
                default=[
                    (
                        "feature_course",
                        {
                            "description_1": "Conheça os principais diferenciais e características que tornam nosso programa único no mercado.",
                            "description_2": "Utilizamos as mais modernas práticas pedagógicas para garantir o melhor aprendizado.",
                            "image": None,
                            "title_1": "Características do Curso",
                            "title_2": "Metodologia Inovadora",
                        },
                    )
                ],
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="templateespecializacao",
            name="feature_estrutura",
            field=wagtail.fields.StreamField(
                [("feature_estrutura", 7)],
                blank=True,
                block_lookup={
                    0: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Estrutura do curso",
                            "help_text": "Título da seção",
                            "required": True,
                        },
                    ),
                    1: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "1º Módulo",
                            "help_text": "Título do módulo (ex: 1º Módulo)",
                            "required": True,
                        },
                    ),
                    2: (
                        "wagtail.blocks.TextBlock",
                        (),
                        {
                            "default": "Descreva o módulo",
                            "help_text": "Descrição breve do módulo",
                            "required": True,
                        },
                    ),
                    3: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "help_text": "Item da lista de conteúdo do módulo",
                            "required": True,
                        },
                    ),
                    4: ("wagtail.blocks.ListBlock", (3,), {}),
                    5: (
                        "wagtail.blocks.StructBlock",
                        [
                            [
                                ("module_title", 1),
                                ("module_description", 2),
                                ("module_items", 4),
                            ]
                        ],
                        {},
                    ),
                    6: (
                        "wagtail.blocks.ListBlock",
                        (5,),
                        {"help_text": "Adicione os módulos do curso", "min_num": 1},
                    ),
                    7: (
                        "wagtail.blocks.StructBlock",
                        [[("title", 0), ("modules", 6)]],
                        {},
                    ),
                },
                default=[
                    (
                        "feature_estrutura",
                        {
                            "modules": [
                                {
                                    "module_description": "Módulo introdutório com os conceitos fundamentais da área",
                                    "module_items": [
                                        "Conceitos básicos e terminologias",
                                        "Fundamentos teóricos essenciais",
                                        "Práticas introdutórias",
                                        "Estudos de caso iniciais",
                                    ],
                                    "module_title": "1º Módulo - Fundamentos",
                                },
                                {
                                    "module_description": "Aprofundamento nos conhecimentos e técnicas avançadas",
                                    "module_items": [
                                        "Técnicas avançadas",
                                        "Metodologias práticas",
                                        "Projetos aplicados",
                                        "Análise de casos reais",
                                    ],
                                    "module_title": "2º Módulo - Desenvolvimento",
                                },
                                {
                                    "module_description": "Especialização e aplicação prática dos conhecimentos",
                                    "module_items": [
                                        "Tópicos especializados",
                                        "Projeto final",
                                        "Apresentação e defesa",
                                        "Networking e mercado",
                                    ],
                                    "module_title": "3º Módulo - Especialização",
                                },
                            ],
                            "title": "Estrutura do Curso",
                        },
                    )
                ],
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="templateespecializacao",
            name="feature_processo_seletivo",
            field=wagtail.fields.StreamField(
                [("feature_processo_seletivo", 8)],
                blank=True,
                block_lookup={
                    0: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Processo seletivo",
                            "help_text": "Título da seção",
                            "required": True,
                        },
                    ),
                    1: (
                        "wagtail.blocks.TextBlock",
                        (),
                        {
                            "default": "Sobre o processo seletivo",
                            "help_text": "Descrição do processo seletivo",
                            "required": True,
                        },
                    ),
                    2: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Inscrição",
                            "help_text": "Título do primeiro módulo",
                            "required": True,
                        },
                    ),
                    3: (
                        "wagtail.blocks.TextBlock",
                        (),
                        {
                            "default": "Lorem ipsum dolor sit amet, lorem ipsum dolor sit amet",
                            "help_text": "Descrição do primeiro módulo",
                            "required": True,
                        },
                    ),
                    4: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Seleção",
                            "help_text": "Título do segundo módulo",
                            "required": True,
                        },
                    ),
                    5: (
                        "wagtail.blocks.TextBlock",
                        (),
                        {
                            "default": "Lorem ipsum dolor sit amet, lorem ipsum dolor sit amet",
                            "help_text": "Descrição do segundo módulo",
                            "required": True,
                        },
                    ),
                    6: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Resultado",
                            "help_text": "Título do terceiro módulo",
                            "required": True,
                        },
                    ),
                    7: (
                        "wagtail.blocks.TextBlock",
                        (),
                        {
                            "default": "Lorem ipsum dolor sit amet, lorem ipsum dolor sit amet",
                            "help_text": "Descrição do terceiro módulo",
                            "required": True,
                        },
                    ),
                    8: (
                        "wagtail.blocks.StructBlock",
                        [
                            [
                                ("title", 0),
                                ("description", 1),
                                ("module1_title", 2),
                                ("module1_description", 3),
                                ("module2_title", 4),
                                ("module2_description", 5),
                                ("module3_title", 6),
                                ("module3_description", 7),
                            ]
                        ],
                        {},
                    ),
                },
                default=[
                    (
                        "feature_processo_seletivo",
                        {
                            "description": "Conheça as etapas do nosso processo seletivo e saiba como participar",
                            "module1_description": "Realize sua inscrição através do nosso portal online. Preencha todos os dados solicitados e anexe a documentação necessária.",
                            "module1_title": "Inscrição",
                            "module2_description": "Nossa equipe realizará uma análise criteriosa do seu perfil profissional e acadêmico para verificar a adequação ao programa.",
                            "module2_title": "Análise Curricular",
                            "module3_description": "Os candidatos aprovados serão comunicados via e-mail e receberão todas as orientações para início do curso.",
                            "module3_title": "Resultado Final",
                            "title": "Processo Seletivo",
                        },
                    )
                ],
                null=True,
            ),
        ),
        migrations.AlterField(
            model_name="templateespecializacao",
            name="team_carousel",
            field=wagtail.fields.StreamField(
                [("team_carousel", 8)],
                blank=True,
                block_lookup={
                    0: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Nossa Equipe",
                            "help_text": "Título da seção",
                            "required": True,
                        },
                    ),
                    1: (
                        "wagtail.blocks.TextBlock",
                        (),
                        {
                            "default": "Equipe de desenvolvedores e etc",
                            "help_text": "Descrição da seção da equipe",
                            "required": True,
                        },
                    ),
                    2: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Ver todos",
                            "help_text": "Texto do botão 'ver todos'",
                            "required": False,
                        },
                    ),
                    3: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {"help_text": "Nome do membro da equipe", "required": True},
                    ),
                    4: (
                        "wagtail.blocks.RichTextBlock",
                        (),
                        {"help_text": "Cargo/função do membro", "required": True},
                    ),
                    5: (
                        "wagtail.images.blocks.ImageChooserBlock",
                        (),
                        {"help_text": "Foto do membro da equipe", "required": False},
                    ),
                    6: (
                        "wagtail.blocks.StructBlock",
                        [[("name", 3), ("role", 4), ("image", 5)]],
                        {},
                    ),
                    7: (
                        "wagtail.blocks.ListBlock",
                        (6,),
                        {
                            "collapsed": False,
                            "default": [
                                {"image": None, "name": "Membro 1", "role": "Cargo 1"},
                                {"image": None, "name": "Membro 2", "role": "Cargo 2"},
                                {"image": None, "name": "Membro 3", "role": "Cargo 3"},
                                {"image": None, "name": "Membro 4", "role": "Cargo 4"},
                            ],
                            "help_text": "Adicione os membros da equipe",
                        },
                    ),
                    8: (
                        "wagtail.blocks.StructBlock",
                        [
                            [
                                ("title", 0),
                                ("description", 1),
                                ("view_all_text", 2),
                                ("members", 7),
                            ]
                        ],
                        {},
                    ),
                },
                default=[
                    (
                        "team_carousel",
                        {
                            "description": "Conheça os profissionais especializados que compõem nosso corpo docente",
                            "members": [
                                {
                                    "image": None,
                                    "name": "Prof. Dr. Nome Sobrenome",
                                    "role": "<p>Coordenador Acadêmico</p>",
                                },
                                {
                                    "image": None,
                                    "name": "Prof. Mestre Nome Sobrenome",
                                    "role": "<p>Docente Especialista</p>",
                                },
                                {
                                    "image": None,
                                    "name": "Prof. Dr. Nome Sobrenome",
                                    "role": "<p>Professor Convidado</p>",
                                },
                                {
                                    "image": None,
                                    "name": "Prof. Mestre Nome Sobrenome",
                                    "role": "<p>Consultor Especializado</p>",
                                },
                            ],
                            "title": "Nossa Equipe",
                            "view_all_text": "Ver todos os professores",
                        },
                    )
                ],
                null=True,
            ),
        ),
    ]
