# Generated by Django 5.1.6 on 2025-06-03 00:24

import django.db.models.deletion
import wagtail.fields
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        (
            "enap_designsystem",
            "0150_poseventopage_footer_poseventopage_navbar_and_more",
        ),
        ("wagtailcore", "0094_alter_page_locale"),
    ]

    operations = [
        migrations.CreateModel(
            name="CursoEadPage",
            fields=[
                (
                    "page_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="wagtailcore.page",
                    ),
                ),
                (
                    "banner_curso",
                    wagtail.fields.StreamField(
                        [("enap_herobanner", 3), ("hero", 16)],
                        blank=True,
                        block_lookup={
                            0: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {"label": "Background Image", "required": False},
                            ),
                            1: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Título do Banner",
                                    "label": "Title",
                                    "max_length": 255,
                                    "required": True,
                                },
                            ),
                            2: (
                                "wagtail.blocks.RichTextBlock",
                                (),
                                {
                                    "default": "Descrição do banner. Edite este texto para personalizar o conteúdo.",
                                    "features": [
                                        "bold",
                                        "italic",
                                        "ol",
                                        "ul",
                                        "hr",
                                        "link",
                                        "document-link",
                                    ],
                                    "label": "Description",
                                    "required": True,
                                },
                            ),
                            3: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("background_image", 0),
                                        ("title", 1),
                                        ("description", 2),
                                    ]
                                ],
                                {},
                            ),
                            4: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "help_text": "Texto principal do hero",
                                    "label": "Título Principal",
                                    "required": True,
                                },
                            ),
                            5: (
                                "wagtail.blocks.TextBlock",
                                (),
                                {
                                    "help_text": "Texto de apoio abaixo do título",
                                    "label": "Subtítulo",
                                    "required": True,
                                },
                            ),
                            6: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("#024248", "Verde ENAP (#024248)"),
                                        ("#007D7A", "Verde Link ENAP (#007D7A)"),
                                        ("#AD6BFC", "Roxo Gnova (#AD6BFC)"),
                                        ("#B396FC", "Roxo Claro Gnova (#B396FC)"),
                                    ],
                                    "help_text": "Cor principal dos elementos destacados",
                                    "label": "Cor Primária",
                                },
                            ),
                            7: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("#024248", "Verde ENAP (#024248)"),
                                        ("#007D7A", "Verde Link ENAP (#007D7A)"),
                                        ("#AD6BFC", "Roxo Gnova (#AD6BFC)"),
                                        ("#B396FC", "Roxo Claro Gnova (#B396FC)"),
                                    ],
                                    "help_text": "Cor de destaque secundária",
                                    "label": "Cor de Destaque",
                                },
                            ),
                            8: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("#FFFFFF", "Branco (#FFFFFF)"),
                                        ("#F8F9FA", "Cinza Claro (#F8F9FA)"),
                                        ("#000000", "Preto (#000000)"),
                                        ("#024248", "Verde ENAP (#024248)"),
                                        ("#007D7A", "Verde Link ENAP (#007D7A)"),
                                        ("#AD6BFC", "Roxo Gnova (#AD6BFC)"),
                                        ("#B396FC", "Roxo Claro Gnova (#B396FC)"),
                                    ],
                                    "help_text": "Cor de fundo da seção (se não usar imagem)",
                                    "label": "Cor de Fundo",
                                },
                            ),
                            9: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Saiba mais",
                                    "help_text": "Texto do botão principal",
                                    "label": "Texto do Botão Primário",
                                    "max_length": 50,
                                    "required": False,
                                },
                            ),
                            10: (
                                "wagtail.blocks.URLBlock",
                                (),
                                {
                                    "default": "#",
                                    "help_text": "URL do botão principal",
                                    "label": "Link do Botão Primário",
                                    "required": False,
                                },
                            ),
                            11: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Assistir vídeo",
                                    "help_text": "Texto do botão secundário",
                                    "label": "Texto do Botão Secundário",
                                    "max_length": 50,
                                    "required": False,
                                },
                            ),
                            12: (
                                "wagtail.blocks.URLBlock",
                                (),
                                {
                                    "default": "#",
                                    "help_text": "URL do botão secundário",
                                    "label": "Link do Botão Secundário",
                                    "required": False,
                                },
                            ),
                            13: (
                                "wagtail.blocks.BooleanBlock",
                                (),
                                {
                                    "default": True,
                                    "help_text": "Exibir ícone de play no botão secundário",
                                    "label": "Mostrar Ícone de Play",
                                    "required": False,
                                },
                            ),
                            14: (
                                "wagtail.blocks.BooleanBlock",
                                (),
                                {
                                    "default": True,
                                    "help_text": "Exibir botão de play sobreposto na imagem de fundo",
                                    "label": "Mostrar Botão de Play na Imagem",
                                    "required": False,
                                },
                            ),
                            15: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {
                                    "help_text": "Imagem de fundo da seção hero",
                                    "label": "Imagem de Fundo",
                                    "required": True,
                                },
                            ),
                            16: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("title", 4),
                                        ("subtitle", 5),
                                        ("primary_color", 6),
                                        ("accent_color", 7),
                                        ("background_color", 8),
                                        ("primary_button_text", 9),
                                        ("primary_button_url", 10),
                                        ("secondary_button_text", 11),
                                        ("secondary_button_url", 12),
                                        ("show_play_icon", 13),
                                        ("show_play_button", 14),
                                        ("background_image", 15),
                                    ]
                                ],
                                {},
                            ),
                        },
                    ),
                ),
                (
                    "apresentacao_curso",
                    wagtail.fields.StreamField(
                        [("course_intro_topics", 6), ("feature_course", 12)],
                        blank=True,
                        block_lookup={
                            0: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Título do Curso",
                                    "help_text": "Título principal sobre o curso",
                                    "label": "Título do Curso",
                                    "required": True,
                                },
                            ),
                            1: (
                                "enap_designsystem.blocks.html_blocks.RichTextBlock",
                                (),
                                {
                                    "default": "Descreva o curso",
                                    "help_text": "Descrição geral do curso",
                                    "label": "Descrição do Curso",
                                    "required": True,
                                },
                            ),
                            2: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {
                                    "help_text": "Imagem para destacar o curso",
                                    "label": "Imagem",
                                    "required": True,
                                },
                            ),
                            3: (
                                "enap_designsystem.blocks.html_blocks.RichTextBlock",
                                (),
                                {
                                    "default": "Descreva a modalidade do curso",
                                    "help_text": "Descreva a modalidade do curso",
                                    "label": "Descrição da Modalidade",
                                    "required": True,
                                },
                            ),
                            4: (
                                "enap_designsystem.blocks.html_blocks.RichTextBlock",
                                (),
                                {
                                    "default": "Descreva o conteúdo do curso",
                                    "help_text": "Descreva o conteúdo do curso",
                                    "label": "Descrição do Curso",
                                    "required": True,
                                },
                            ),
                            5: (
                                "enap_designsystem.blocks.html_blocks.RichTextBlock",
                                (),
                                {
                                    "default": "Descreva a metodologia do curso",
                                    "help_text": "Descreva a metodologia do curso",
                                    "label": "Descrição da Metodologia",
                                    "required": True,
                                },
                            ),
                            6: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("title", 0),
                                        ("description", 1),
                                        ("image", 2),
                                        ("modalidade_description", 3),
                                        ("curso_description", 4),
                                        ("metodologia_description", 5),
                                    ]
                                ],
                                {},
                            ),
                            7: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Título da feature",
                                    "help_text": "Primeiro título da feature",
                                    "required": True,
                                },
                            ),
                            8: (
                                "wagtail.blocks.TextBlock",
                                (),
                                {
                                    "default": "Descrição da feature",
                                    "help_text": "Primeira descrição da feature",
                                    "required": True,
                                },
                            ),
                            9: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Título da feature",
                                    "help_text": "Segundo título da feature",
                                    "required": True,
                                },
                            ),
                            10: (
                                "wagtail.blocks.TextBlock",
                                (),
                                {
                                    "default": "Descrição da feature",
                                    "help_text": "Segunda descrição da feature",
                                    "required": True,
                                },
                            ),
                            11: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {
                                    "help_text": "Imagem da feature do curso",
                                    "required": False,
                                },
                            ),
                            12: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("title_1", 7),
                                        ("description_1", 8),
                                        ("title_2", 9),
                                        ("description_2", 10),
                                        ("image", 11),
                                    ]
                                ],
                                {},
                            ),
                        },
                    ),
                ),
                (
                    "estrutura_curso",
                    wagtail.fields.StreamField(
                        [("feature_estrutura", 7), ("section_tabs_cards", 28)],
                        blank=True,
                        block_lookup={
                            0: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Estrutura do curso",
                                    "help_text": "Título da seção",
                                    "required": True,
                                },
                            ),
                            1: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "1º Módulo",
                                    "help_text": "Título do módulo (ex: 1º Módulo)",
                                    "required": True,
                                },
                            ),
                            2: (
                                "wagtail.blocks.TextBlock",
                                (),
                                {
                                    "default": "Descreva o módulo",
                                    "help_text": "Descrição breve do módulo",
                                    "required": True,
                                },
                            ),
                            3: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "help_text": "Item da lista de conteúdo do módulo",
                                    "required": True,
                                },
                            ),
                            4: ("wagtail.blocks.ListBlock", (3,), {}),
                            5: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("module_title", 1),
                                        ("module_description", 2),
                                        ("module_items", 4),
                                    ]
                                ],
                                {},
                            ),
                            6: (
                                "wagtail.blocks.ListBlock",
                                (5,),
                                {
                                    "help_text": "Adicione os módulos do curso",
                                    "min_num": 1,
                                },
                            ),
                            7: (
                                "wagtail.blocks.StructBlock",
                                [[("title", 0), ("modules", 6)]],
                                {},
                            ),
                            8: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Título da Seção",
                                    "label": "Título da Seção",
                                    "required": True,
                                },
                            ),
                            9: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "",
                                    "help_text": "Parte do título que terá gradiente (opcional)",
                                    "label": "Texto Destacado",
                                    "required": False,
                                },
                            ),
                            10: (
                                "enap_designsystem.blocks.html_blocks.RichTextBlock",
                                (),
                                {
                                    "default": "<p>Subtítulo da seção com informações relevantes.</p>",
                                    "label": "Subtítulo da Seção",
                                    "required": True,
                                },
                            ),
                            11: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Título da Aba",
                                    "label": "Título da Aba",
                                    "required": True,
                                },
                            ),
                            12: (
                                "wagtail.blocks.BooleanBlock",
                                (),
                                {
                                    "default": False,
                                    "label": "Ativar por padrão",
                                    "required": False,
                                },
                            ),
                            13: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Título do Card",
                                    "label": "Título do Card",
                                    "required": False,
                                },
                            ),
                            14: (
                                "enap_designsystem.blocks.html_blocks.RichTextBlock",
                                (),
                                {
                                    "default": "<p>Descrição detalhada do card com informações importantes para o usuário.</p>",
                                    "label": "Descrição do Card",
                                    "required": False,
                                },
                            ),
                            15: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "fa-solid fa-star",
                                    "help_text": "Cole o código do Font Awesome aqui (ex: 'fa-solid fa-book')",
                                    "label": "Classe do Ícone",
                                    "required": False,
                                },
                            ),
                            16: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Acessar",
                                    "label": "Texto do Link",
                                    "required": False,
                                },
                            ),
                            17: (
                                "wagtail.blocks.URLBlock",
                                (),
                                {
                                    "default": "https://gov.br/",
                                    "label": "URL do Link",
                                    "required": False,
                                },
                            ),
                            18: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "#FF7E38",
                                    "help_text": "Insira um código de cor HEX (ex: #5E17EB)",
                                    "label": "Cor de Destaque",
                                    "required": True,
                                },
                            ),
                            19: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("title", 13),
                                        ("description", 14),
                                        ("icon_class", 15),
                                        ("link_text", 16),
                                        ("link_url", 17),
                                        ("highlight_color", 18),
                                    ]
                                ],
                                {},
                            ),
                            20: (
                                "wagtail.blocks.ListBlock",
                                (19,),
                                {"default": [], "label": "Cards"},
                            ),
                            21: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("grid", "Grid - Cards em forma de grade"),
                                        ("list", "Lista - Cards em formato de lista"),
                                    ],
                                    "label": "Tipo de Layout",
                                },
                            ),
                            22: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("2", "2 Colunas"),
                                        ("3", "3 Colunas"),
                                        ("4", "4 Colunas"),
                                        ("5", "5 Colunas"),
                                    ],
                                    "label": "Número de Colunas",
                                },
                            ),
                            23: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("tab_title", 11),
                                        ("is_default_active", 12),
                                        ("cards", 20),
                                        ("layout_type", 21),
                                        ("columns", 22),
                                    ]
                                ],
                                {},
                            ),
                            24: (
                                "wagtail.blocks.ListBlock",
                                (23,),
                                {"default": [], "label": "Abas"},
                            ),
                            25: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("#024248", "Verde ENAP (#024248)"),
                                        ("#007D7A", "Verde Link ENAP (#007D7A)"),
                                        ("#AD6BFC", "Roxo Gnova (#AD6BFC)"),
                                        ("#B396FC", "Roxo Claro Gnova (#B396FC)"),
                                    ],
                                    "help_text": "Selecione a cor principal do componente",
                                    "label": "Cor Primária",
                                },
                            ),
                            26: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("#024248", "Verde ENAP (#024248)"),
                                        ("#007D7A", "Verde Link ENAP (#007D7A)"),
                                        ("#AD6BFC", "Roxo Gnova (#AD6BFC)"),
                                        ("#B396FC", "Roxo Claro Gnova (#B396FC)"),
                                    ],
                                    "help_text": "Selecione a cor secundária do componente",
                                    "label": "Cor Secundária",
                                },
                            ),
                            27: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "#FFFFFF",
                                    "help_text": "Cor de fundo da seção (ex: #FFFFFF)",
                                    "label": "Cor de Fundo",
                                    "required": True,
                                },
                            ),
                            28: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("title", 8),
                                        ("highlight_text", 9),
                                        ("subtitle", 10),
                                        ("tabs", 24),
                                        ("primary_color", 25),
                                        ("secondary_color", 26),
                                        ("background_color", 27),
                                    ]
                                ],
                                {},
                            ),
                        },
                    ),
                ),
                (
                    "vantagens",
                    wagtail.fields.StreamField(
                        [("why_choose", 10), ("feature_list", 21)],
                        blank=True,
                        block_lookup={
                            0: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Titulo do beneficio",
                                    "label": "Título principal",
                                    "required": True,
                                },
                            ),
                            1: (
                                "wagtail.blocks.TextBlock",
                                (),
                                {
                                    "default": "Titulo do beneficio",
                                    "label": "Descrição principal",
                                    "required": False,
                                },
                            ),
                            2: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {"label": "Imagem do benefício 1", "required": False},
                            ),
                            3: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Metodologia ensino–aplicação",
                                    "label": "Título do benefício 1",
                                    "required": True,
                                },
                            ),
                            4: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {"label": "Imagem do benefício 2", "required": False},
                            ),
                            5: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Desenvolvimento de competências de forma inovadora",
                                    "label": "Título do benefício 2",
                                    "required": True,
                                },
                            ),
                            6: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {"label": "Imagem do benefício 3", "required": False},
                            ),
                            7: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Desenvolvimento de competências de forma inovadora",
                                    "label": "Título do benefício 3",
                                    "required": True,
                                },
                            ),
                            8: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {"label": "Imagem do benefício 4", "required": False},
                            ),
                            9: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Desenvolvimento de competências de forma inovadora",
                                    "label": "Título do benefício 4",
                                    "required": True,
                                },
                            ),
                            10: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("title", 0),
                                        ("description", 1),
                                        ("image_1", 2),
                                        ("title_1", 3),
                                        ("image_2", 4),
                                        ("title_2", 5),
                                        ("image_3", 6),
                                        ("title_3", 7),
                                        ("image_4", 8),
                                        ("title_4", 9),
                                    ]
                                ],
                                {},
                            ),
                            11: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {"help_text": "Main featured image", "required": True},
                            ),
                            12: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {"help_text": "Featured item title", "required": True},
                            ),
                            13: (
                                "wagtail.blocks.RichTextBlock",
                                (),
                                {
                                    "help_text": "Featured item description",
                                    "required": True,
                                },
                            ),
                            14: (
                                "wagtail.blocks.URLBlock",
                                (),
                                {
                                    "help_text": "Link for the featured item",
                                    "label": "URL do link",
                                    "required": True,
                                },
                            ),
                            15: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {"help_text": "Item image", "required": True},
                            ),
                            16: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {"help_text": "Item title", "required": True},
                            ),
                            17: (
                                "wagtail.blocks.RichTextBlock",
                                (),
                                {"help_text": "Item description", "required": True},
                            ),
                            18: (
                                "wagtail.blocks.URLBlock",
                                (),
                                {"label": "URL do link"},
                            ),
                            19: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("image", 15),
                                        ("title", 16),
                                        ("description", 17),
                                        ("link_url", 18),
                                    ]
                                ],
                                {},
                            ),
                            20: (
                                "wagtail.blocks.ListBlock",
                                (19,),
                                {
                                    "help_text": "Add items to be displayed on the right side",
                                    "min_num": 1,
                                },
                            ),
                            21: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("featured_image", 11),
                                        ("featured_title", 12),
                                        ("featured_description", 13),
                                        ("featured_link_url", 14),
                                        ("list_items", 20),
                                    ]
                                ],
                                {},
                            ),
                        },
                    ),
                ),
                (
                    "depoimentos_alunos",
                    wagtail.fields.StreamField(
                        [("testimonials_carousel", 8)],
                        blank=True,
                        block_lookup={
                            0: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Depoimentos",
                                    "help_text": "Título da seção",
                                    "required": True,
                                },
                            ),
                            1: (
                                "wagtail.blocks.TextBlock",
                                (),
                                {
                                    "help_text": "Descrição opcional da seção",
                                    "required": False,
                                },
                            ),
                            2: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Nome do profissional",
                                    "help_text": "Nome da pessoa",
                                    "required": True,
                                },
                            ),
                            3: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Cargo do profissional",
                                    "help_text": "Cargo ou posição da pessoa",
                                    "required": True,
                                },
                            ),
                            4: (
                                "wagtail.blocks.TextBlock",
                                (),
                                {
                                    "default": "Lorem ipsum dolor sit amet, lorem ipsum dolor sit amet",
                                    "help_text": "Depoimento da pessoa",
                                    "required": True,
                                },
                            ),
                            5: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {"help_text": "Foto da pessoa", "required": True},
                            ),
                            6: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("name", 2),
                                        ("position", 3),
                                        ("testimonial", 4),
                                        ("image", 5),
                                    ]
                                ],
                                {},
                            ),
                            7: (
                                "wagtail.blocks.ListBlock",
                                (6,),
                                {"help_text": "Adicione os depoimentos"},
                            ),
                            8: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("title", 0),
                                        ("description", 1),
                                        ("testimonials", 7),
                                    ]
                                ],
                                {},
                            ),
                        },
                    ),
                ),
                (
                    "cursos_relacionados",
                    wagtail.fields.StreamField(
                        [("preview_courses", 5), ("carrossel_cursos", 31)],
                        blank=True,
                        block_lookup={
                            0: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [("", "Default")],
                                    "label": "Template",
                                    "required": False,
                                },
                            ),
                            1: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "label": "Custom CSS Class",
                                    "max_length": 255,
                                    "required": False,
                                },
                            ),
                            2: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "label": "Custom ID",
                                    "max_length": 255,
                                    "required": False,
                                },
                            ),
                            3: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("custom_template", 0),
                                        ("custom_css_class", 1),
                                        ("custom_id", 2),
                                    ]
                                ],
                                {},
                            ),
                            4: (
                                "wagtail.blocks.PageChooserBlock",
                                (),
                                {
                                    "help_text": "Show a mini preview of the selected page.",
                                    "label": "Pagina de Formações",
                                    "required": True,
                                },
                            ),
                            5: (
                                "wagtail.blocks.StructBlock",
                                [[("settings", 3), ("page", 4)]],
                                {},
                            ),
                            6: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("card-curso-em-breve", "Curso em breve"),
                                        ("card-curso-aberto", "Curso aberto"),
                                        ("card-curso-andamento", "Curso em andamento"),
                                        ("card-curso-encerrado", "Curso encerrado"),
                                    ],
                                    "help_text": "Escolha o status do curso",
                                    "label": "Status do curso",
                                },
                            ),
                            7: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "label": "Título do curso",
                                    "max_length": 255,
                                    "required": True,
                                },
                            ),
                            8: (
                                "wagtail.blocks.RichTextBlock",
                                (),
                                {
                                    "features": [
                                        "bold",
                                        "italic",
                                        "ol",
                                        "ul",
                                        "hr",
                                        "link",
                                        "document-link",
                                    ],
                                    "label": "Descrição",
                                },
                            ),
                            9: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "label": "Carga horária",
                                    "max_length": 50,
                                    "required": True,
                                },
                            ),
                            10: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("presencial", "Presencial"),
                                        ("online", "Online"),
                                        ("hibrido", "Híbrido"),
                                    ],
                                    "label": "Modalidade",
                                },
                            ),
                            11: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("#024248", "Verde ENAP (#024248)"),
                                        ("#007D7A", "Verde Link ENAP (#007D7A)"),
                                        ("#AD6BFC", "Roxo Gnova (#AD6BFC)"),
                                        ("#B396FC", "Roxo Claro Gnova (#B396FC)"),
                                    ],
                                    "help_text": "Cor que será aplicada no texto destacado e nos cards",
                                    "label": "Cor de Destaque",
                                },
                            ),
                            12: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "label": "Tracking Event Category",
                                    "max_length": 255,
                                    "required": False,
                                },
                            ),
                            13: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "label": "Tracking Event Label",
                                    "max_length": 255,
                                    "required": False,
                                },
                            ),
                            14: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("custom_template", 0),
                                        ("custom_css_class", 1),
                                        ("custom_id", 2),
                                        ("ga_tracking_event_category", 12),
                                        ("ga_tracking_event_label", 13),
                                    ]
                                ],
                                {},
                            ),
                            15: (
                                "wagtail.blocks.PageChooserBlock",
                                (),
                                {"label": "Page link", "required": False},
                            ),
                            16: (
                                "wagtail.documents.blocks.DocumentChooserBlock",
                                (),
                                {"label": "Document link", "required": False},
                            ),
                            17: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "label": "Other link",
                                    "max_length": 255,
                                    "required": False,
                                },
                            ),
                            18: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "label": "Title",
                                    "max_length": 255,
                                    "required": False,
                                },
                            ),
                            19: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("primary", "Tipo primário"),
                                        ("secondary", "Tipo secundário"),
                                        ("terciary", "Tipo terciário"),
                                    ],
                                    "help_text": "Escolha o tipo do botão",
                                    "label": "Tipo de botão",
                                },
                            ),
                            20: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("small", "Pequeno"),
                                        ("medium", "Médio"),
                                        ("large", "Grande"),
                                        ("extra-large", "Extra grande"),
                                    ],
                                    "help_text": "Escolha o tamanho do botão",
                                    "label": "Tamanho",
                                },
                            ),
                            21: (
                                "wagtail.blocks.BooleanBlock",
                                (),
                                {"label": "Icone", "required": False},
                            ),
                            22: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("settings", 14),
                                        ("page_link", 15),
                                        ("doc_link", 16),
                                        ("other_link", 17),
                                        ("button_title", 18),
                                        ("type_class", 19),
                                        ("size_class", 20),
                                        ("icone_bool", 21),
                                    ]
                                ],
                                {},
                            ),
                            23: (
                                "wagtail.blocks.StreamBlock",
                                [[("button", 22)]],
                                {
                                    "blank": True,
                                    "label": "Botão (link)",
                                    "max_num": 1,
                                    "required": False,
                                },
                            ),
                            24: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("settings", 3),
                                        ("type", 6),
                                        ("title", 7),
                                        ("description", 8),
                                        ("carga_horaria", 9),
                                        ("modalidade", 10),
                                        ("highlight_color", 11),
                                        ("link", 23),
                                    ]
                                ],
                                {},
                            ),
                            25: (
                                "wagtail.blocks.StreamBlock",
                                [[("card", 24)]],
                                {
                                    "help_text": "Adicione os cards de curso que deseja exibir no carrossel",
                                    "label": "Cards de Curso",
                                    "min_num": 1,
                                },
                            ),
                            26: (
                                "wagtail.blocks.IntegerBlock",
                                (),
                                {
                                    "default": 1,
                                    "help_text": "Número de cards visíveis em dispositivos móveis",
                                    "label": "Cards por visualização (Mobile)",
                                    "max_value": 2,
                                    "min_value": 1,
                                },
                            ),
                            27: (
                                "wagtail.blocks.IntegerBlock",
                                (),
                                {
                                    "default": 2,
                                    "help_text": "Número de cards visíveis em tablets",
                                    "label": "Cards por visualização (Tablet)",
                                    "max_value": 3,
                                    "min_value": 1,
                                },
                            ),
                            28: (
                                "wagtail.blocks.IntegerBlock",
                                (),
                                {
                                    "default": 3,
                                    "help_text": "Número de cards visíveis em desktops",
                                    "label": "Cards por visualização (Desktop)",
                                    "max_value": 4,
                                    "min_value": 1,
                                },
                            ),
                            29: (
                                "wagtail.blocks.BooleanBlock",
                                (),
                                {
                                    "default": False,
                                    "help_text": "Ativar rolagem automática do carrossel",
                                    "label": "Auto-play",
                                    "required": False,
                                },
                            ),
                            30: (
                                "wagtail.blocks.IntegerBlock",
                                (),
                                {
                                    "default": 5000,
                                    "help_text": "Tempo de espera entre slides em milissegundos (1000 = 1 segundo)",
                                    "label": "Tempo de auto-play",
                                    "min_value": 1000,
                                    "required": False,
                                },
                            ),
                            31: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("cards", 25),
                                        ("slidesPerView_mobile", 26),
                                        ("slidesPerView_tablet", 27),
                                        ("slidesPerView_desktop", 28),
                                        ("auto_play", 29),
                                        ("auto_play_delay", 30),
                                    ]
                                ],
                                {},
                            ),
                        },
                    ),
                ),
                (
                    "inscricao",
                    wagtail.fields.StreamField(
                        [("cta_destaque", 3), ("secao_adesao", 12)],
                        blank=True,
                        block_lookup={
                            0: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Data de Início da Formação",
                                    "help_text": "Título principal do componente",
                                    "label": "Título",
                                    "max_length": 100,
                                },
                            ),
                            1: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {
                                    "help_text": "Imagem personalizada para o ícone (opcional, padrão será ícone de relógio)",
                                    "label": "Ícone Personalizado",
                                    "required": False,
                                },
                            ),
                            2: (
                                "wagtail.blocks.RichTextBlock",
                                (),
                                {
                                    "default": "A formação começa no dia 15 de janeiro de 2024. Inscrições abertas até 10 de janeiro.",
                                    "features": ["bold", "italic", "link"],
                                    "help_text": "Texto com as informações sobre a formação",
                                    "label": "Descrição",
                                },
                            ),
                            3: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("titulo", 0),
                                        ("icone_personalizado", 1),
                                        ("descricao", 2),
                                    ]
                                ],
                                {},
                            ),
                            4: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Como aderir ao Enap Aqui?",
                                    "help_text": "Título da seção informativa (coluna esquerda)",
                                    "max_length": 100,
                                    "required": True,
                                    "verbose_name": "Título",
                                },
                            ),
                            5: (
                                "wagtail.blocks.RichTextBlock",
                                (),
                                {
                                    "default": "<p>A adesão ao Programa Enap Aqui é feita por meio da assinatura de um Acordo de Adesão, formalizado pela instituição interessada.</p><p>O Acordo de Adesão ao Enap Aqui expressa o compromisso da instituição com a promoção de ações formativas voltadas a servidores públicos locais, por meio de uma abordagem híbrida que integra cursos a distância e oficinas presenciais, com foco em temas estratégicos para a gestão pública.</p>",
                                    "help_text": "Texto explicativo sobre o processo de adesão",
                                    "required": True,
                                    "verbose_name": "Texto informativo",
                                },
                            ),
                            6: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Torne-se um parceiro Enap Aqui",
                                    "help_text": "Título do cartão verde de destaque",
                                    "max_length": 100,
                                    "required": True,
                                    "verbose_name": "Título do destaque",
                                },
                            ),
                            7: (
                                "wagtail.blocks.RichTextBlock",
                                (),
                                {
                                    "default": "<p>Faça parte do Enap Aqui e acompanhe o processo:</p>",
                                    "help_text": "Texto curto para o cartão verde de destaque",
                                    "required": True,
                                    "verbose_name": "Texto do destaque",
                                },
                            ),
                            8: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Aderir ao Enap Aqui",
                                    "help_text": "Texto que será exibido no botão",
                                    "max_length": 50,
                                    "required": True,
                                    "verbose_name": "Texto do botão",
                                },
                            ),
                            9: (
                                "wagtail.blocks.URLBlock",
                                (),
                                {
                                    "default": "#",
                                    "help_text": "URL para onde o botão vai redirecionar",
                                    "required": True,
                                    "verbose_name": "URL do botão",
                                },
                            ),
                            10: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "#1F4D4D",
                                    "help_text": "Código hexadecimal da cor de fundo do cartão verde (ex: #1F4D4D)",
                                    "max_length": 7,
                                    "required": False,
                                    "verbose_name": "Cor de fundo do destaque",
                                },
                            ),
                            11: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("pequeno", "Pequeno"),
                                        ("medio", "Médio"),
                                        ("grande", "Grande"),
                                    ],
                                    "help_text": "Espaçamento vertical da seção",
                                    "verbose_name": "Espaçamento",
                                },
                            ),
                            12: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("titulo_informativo", 4),
                                        ("texto_informativo", 5),
                                        ("titulo_destaque", 6),
                                        ("texto_destaque", 7),
                                        ("texto_botao", 8),
                                        ("url_botao", 9),
                                        ("cor_fundo_destaque", 10),
                                        ("espaco_vertical", 11),
                                    ]
                                ],
                                {},
                            ),
                        },
                    ),
                ),
                (
                    "faq_curso",
                    wagtail.fields.StreamField(
                        [("accordion", 5)],
                        blank=True,
                        block_lookup={
                            0: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [("", "Default")],
                                    "label": "Template",
                                    "required": False,
                                },
                            ),
                            1: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "label": "Custom CSS Class",
                                    "max_length": 255,
                                    "required": False,
                                },
                            ),
                            2: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "label": "Custom ID",
                                    "max_length": 255,
                                    "required": False,
                                },
                            ),
                            3: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("custom_template", 0),
                                        ("custom_css_class", 1),
                                        ("custom_id", 2),
                                    ]
                                ],
                                {},
                            ),
                            4: (
                                "wagtail.snippets.blocks.SnippetChooserBlock",
                                ("enap_designsystem.EnapAccordionSnippet",),
                                {},
                            ),
                            5: (
                                "wagtail.blocks.StructBlock",
                                [[("settings", 3), ("accordion", 4)]],
                                {},
                            ),
                        },
                    ),
                ),
                (
                    "footer",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to="enap_designsystem.enapfootersnippet",
                    ),
                ),
                (
                    "navbar",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to="enap_designsystem.enapnavbarsnippet",
                    ),
                ),
            ],
            options={
                "verbose_name": "Enap Curso EAD",
            },
            bases=("wagtailcore.page",),
        ),
    ]
