# Generated by Django 5.1.6 on 2025-06-09 01:43

import django.db.models.deletion
import wagtail.fields
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("enap_designsystem", "0178_alter_concursoinovacao_patrocinadores"),
        ("wagtailcore", "0094_alter_page_locale"),
    ]

    operations = [
        migrations.CreateModel(
            name="EditalConcursoInovacao",
            fields=[
                (
                    "page_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="wagtailcore.page",
                    ),
                ),
                (
                    "banner",
                    wagtail.fields.StreamField(
                        [("banner_concurso", 8)],
                        block_lookup={
                            0: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "help_text": "Título principal do banner",
                                    "max_length": 100,
                                    "required": True,
                                },
                            ),
                            1: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "help_text": "Subtítulo ou descrição do banner",
                                    "max_length": 200,
                                    "required": False,
                                },
                            ),
                            2: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {
                                    "help_text": "Imagem de fundo do banner",
                                    "required": True,
                                },
                            ),
                            3: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {
                                    "help_text": "Imagem principal do banner",
                                    "required": True,
                                },
                            ),
                            4: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {
                                    "help_text": "Segunda imagem do banner",
                                    "required": True,
                                },
                            ),
                            5: (
                                "wagtail.blocks.URLBlock",
                                (),
                                {
                                    "help_text": "URL para onde o banner deve direcionar (opcional)",
                                    "required": False,
                                },
                            ),
                            6: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "help_text": "Texto do botão/link (ex: 'Saiba mais')",
                                    "max_length": 50,
                                    "required": False,
                                },
                            ),
                            7: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("branco", "Branco"),
                                        ("cinza", "Cinza"),
                                        ("azul", "Azul"),
                                        ("verde", "Verde"),
                                    ],
                                    "help_text": "Cor de fundo do conteúdo do banner",
                                },
                            ),
                            8: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("titulo", 0),
                                        ("subtitulo", 1),
                                        ("imagem_fundo", 2),
                                        ("imagem_principal", 3),
                                        ("imagem_secundaria", 4),
                                        ("link", 5),
                                        ("texto_link", 6),
                                        ("cor_fundo", 7),
                                    ]
                                ],
                                {},
                            ),
                        },
                    ),
                ),
                (
                    "apresentacao",
                    wagtail.fields.StreamField(
                        [("secao_apresentacao", 8)],
                        blank=True,
                        block_lookup={
                            0: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "help_text": "Título principal da seção",
                                    "max_length": 200,
                                },
                            ),
                            1: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("#8FBC8F", "Verde Claro"),
                                        ("#9ACD32", "Verde Amarelado"),
                                        ("#32CD32", "Verde Limão"),
                                        ("#228B22", "Verde Floresta"),
                                        ("#FFD700", "Dourado"),
                                        ("#FF6B35", "Laranja"),
                                        ("#87CEEB", "Azul Claro"),
                                        ("#4169E1", "Azul Royal"),
                                        ("#2F4F4F", "Verde Escuro"),
                                        ("#000000", "Preto"),
                                    ],
                                    "help_text": "Cor do título principal",
                                },
                            ),
                            2: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "help_text": "Subtítulo da seção (opcional)",
                                    "max_length": 300,
                                    "required": False,
                                },
                            ),
                            3: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("#2F4F4F", "Verde Escuro"),
                                        ("#000000", "Preto"),
                                        ("#4A4A4A", "Cinza Escuro"),
                                        ("#696969", "Cinza Médio"),
                                        ("#8B4513", "Marrom"),
                                        ("#800080", "Roxo"),
                                        ("#8B0000", "Vermelho Escuro"),
                                        ("#191970", "Azul Marinho"),
                                    ],
                                    "help_text": "Cor do subtítulo",
                                },
                            ),
                            4: (
                                "wagtail.images.blocks.ImageChooserBlock",
                                (),
                                {
                                    "help_text": "Imagem que aparecerá em formato circular"
                                },
                            ),
                            5: (
                                "wagtail.blocks.CharBlock",
                                (),
                                {
                                    "default": "Imagem ilustrativa",
                                    "help_text": "Texto alternativo da imagem",
                                    "max_length": 100,
                                },
                            ),
                            6: (
                                "wagtail.blocks.RichTextBlock",
                                (),
                                {
                                    "features": [
                                        "bold",
                                        "italic",
                                        "link",
                                        "ol",
                                        "ul",
                                        "hr",
                                        "document-link",
                                    ],
                                    "help_text": "Conteúdo principal em rich text",
                                },
                            ),
                            7: (
                                "wagtail.blocks.ChoiceBlock",
                                [],
                                {
                                    "choices": [
                                        ("#2F4F4F", "Verde Escuro"),
                                        ("#000000", "Preto"),
                                        ("#4A4A4A", "Cinza Escuro"),
                                        ("#696969", "Cinza Médio"),
                                        ("#8B4513", "Marrom"),
                                        ("#2C3E50", "Azul Escuro"),
                                    ],
                                    "help_text": "Cor do texto do conteúdo",
                                },
                            ),
                            8: (
                                "wagtail.blocks.StructBlock",
                                [
                                    [
                                        ("titulo", 0),
                                        ("cor_titulo", 1),
                                        ("subtitulo", 2),
                                        ("cor_subtitulo", 3),
                                        ("imagem_circular", 4),
                                        ("alt_imagem", 5),
                                        ("conteudo", 6),
                                        ("cor_texto", 7),
                                    ]
                                ],
                                {},
                            ),
                        },
                    ),
                ),
            ],
            options={
                "verbose_name": "Concurso de inovação - Edital",
                "verbose_name_plural": "Concursos de inovação - Editais",
            },
            bases=("wagtailcore.page",),
        ),
    ]
