# Generated by Django 5.1.6 on 2025-06-09 01:52

import wagtail.fields
from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ("enap_designsystem", "0179_editalconcursoinovacao"),
    ]

    operations = [
        migrations.AlterField(
            model_name="editalconcursoinovacao",
            name="apresentacao",
            field=wagtail.fields.StreamField(
                [("secao_apresentacao", 10)],
                blank=True,
                block_lookup={
                    0: (
                        "wagtail.blocks.ChoiceBlock",
                        [],
                        {
                            "choices": [
                                ("#FFFFFF", "Branco"),
                                ("#F8F9FA", "Cinza Muito Claro"),
                                ("#E8F5E8", "Verde Muito Claro"),
                                ("#FFF8DC", "Bege"),
                                ("#F0F8FF", "Azul Alice"),
                                ("#FFFACD", "Amarelo Claro"),
                                ("#E6E6FA", "Lavanda"),
                                ("#F5F5DC", "Bege Antigo"),
                                ("#F0FFFF", "Azul Claro"),
                                ("#FFEFD5", "Papaya"),
                            ],
                            "help_text": "Cor de fundo da seção",
                        },
                    ),
                    1: (
                        "wagtail.blocks.ChoiceBlock",
                        [],
                        {
                            "choices": [
                                ("direita", "Imagem à Direita"),
                                ("esquerda", "Imagem à Esquerda"),
                            ],
                            "help_text": "Posição da imagem em relação ao texto",
                        },
                    ),
                    2: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {"help_text": "Título principal da seção", "max_length": 200},
                    ),
                    3: (
                        "wagtail.blocks.ChoiceBlock",
                        [],
                        {
                            "choices": [
                                ("#8FBC8F", "Verde Claro"),
                                ("#9ACD32", "Verde Amarelado"),
                                ("#32CD32", "Verde Limão"),
                                ("#228B22", "Verde Floresta"),
                                ("#FFD700", "Dourado"),
                                ("#FF6B35", "Laranja"),
                                ("#87CEEB", "Azul Claro"),
                                ("#4169E1", "Azul Royal"),
                                ("#2F4F4F", "Verde Escuro"),
                                ("#000000", "Preto"),
                            ],
                            "help_text": "Cor do título principal",
                        },
                    ),
                    4: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "help_text": "Subtítulo da seção (opcional)",
                            "max_length": 300,
                            "required": False,
                        },
                    ),
                    5: (
                        "wagtail.blocks.ChoiceBlock",
                        [],
                        {
                            "choices": [
                                ("#2F4F4F", "Verde Escuro"),
                                ("#000000", "Preto"),
                                ("#4A4A4A", "Cinza Escuro"),
                                ("#696969", "Cinza Médio"),
                                ("#8B4513", "Marrom"),
                                ("#800080", "Roxo"),
                                ("#8B0000", "Vermelho Escuro"),
                                ("#191970", "Azul Marinho"),
                            ],
                            "help_text": "Cor do subtítulo",
                        },
                    ),
                    6: (
                        "wagtail.images.blocks.ImageChooserBlock",
                        (),
                        {"help_text": "Imagem que aparecerá em formato circular"},
                    ),
                    7: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "default": "Imagem ilustrativa",
                            "help_text": "Texto alternativo da imagem",
                            "max_length": 100,
                        },
                    ),
                    8: (
                        "wagtail.blocks.RichTextBlock",
                        (),
                        {
                            "features": [
                                "bold",
                                "italic",
                                "link",
                                "ol",
                                "ul",
                                "hr",
                                "document-link",
                            ],
                            "help_text": "Conteúdo principal em rich text",
                        },
                    ),
                    9: (
                        "wagtail.blocks.ChoiceBlock",
                        [],
                        {
                            "choices": [
                                ("#2F4F4F", "Verde Escuro"),
                                ("#000000", "Preto"),
                                ("#4A4A4A", "Cinza Escuro"),
                                ("#696969", "Cinza Médio"),
                                ("#8B4513", "Marrom"),
                                ("#2C3E50", "Azul Escuro"),
                            ],
                            "help_text": "Cor do texto do conteúdo",
                        },
                    ),
                    10: (
                        "wagtail.blocks.StructBlock",
                        [
                            [
                                ("cor_fundo", 0),
                                ("posicao_imagem", 1),
                                ("titulo", 2),
                                ("cor_titulo", 3),
                                ("subtitulo", 4),
                                ("cor_subtitulo", 5),
                                ("imagem_circular", 6),
                                ("alt_imagem", 7),
                                ("conteudo", 8),
                                ("cor_texto", 9),
                            ]
                        ],
                        {},
                    ),
                },
            ),
        ),
    ]
