# Generated by Django 5.1.6 on 2025-06-09 03:40

import wagtail.fields
from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ("enap_designsystem", "0188_sejaavaliador_alter_areaaluno_body_and_more"),
    ]

    operations = [
        migrations.RemoveField(
            model_name="sejaavaliador",
            name="premios",
        ),
        migrations.AddField(
            model_name="sejaavaliador",
            name="cronograma",
            field=wagtail.fields.StreamField(
                [("cronograma", 10)],
                blank=True,
                block_lookup={
                    0: (
                        "wagtail.images.blocks.ImageChooserBlock",
                        (),
                        {
                            "help_text": "Imagem de fundo da seção (opcional)",
                            "required": False,
                        },
                    ),
                    1: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {
                            "help_text": "Título do cronograma (ex: De olho no cronograma)",
                            "max_length": 200,
                        },
                    ),
                    2: (
                        "wagtail.blocks.ChoiceBlock",
                        [],
                        {
                            "choices": [
                                ("#2F4F4F", "Verde Escuro"),
                                ("#000000", "Preto"),
                                ("#4A4A4A", "Cinza Escuro"),
                                ("#696969", "Cinza Médio"),
                                ("#8B4513", "Marrom"),
                                ("#800080", "Roxo"),
                                ("#8B0000", "Vermelho Escuro"),
                                ("#191970", "Azul Marinho"),
                            ],
                            "help_text": "Cor do título",
                        },
                    ),
                    3: (
                        "wagtail.blocks.CharBlock",
                        (),
                        {"help_text": "Data do step (ex: 05 MAI)", "max_length": 50},
                    ),
                    4: (
                        "wagtail.blocks.ChoiceBlock",
                        [],
                        {
                            "choices": [
                                ("#2F4F4F", "Verde Escuro"),
                                ("#000000", "Preto"),
                                ("#4A4A4A", "Cinza Escuro"),
                                ("#696969", "Cinza Médio"),
                                ("#8B4513", "Marrom"),
                            ],
                            "help_text": "Cor do texto da data",
                        },
                    ),
                    5: (
                        "wagtail.blocks.ChoiceBlock",
                        [],
                        {
                            "choices": [
                                ("#9ACD32", "Verde Amarelado"),
                                ("#8FBC8F", "Verde Claro"),
                                ("#32CD32", "Verde Limão"),
                                ("#228B22", "Verde Floresta"),
                                ("#FFD700", "Dourado"),
                                ("#FF6B35", "Laranja"),
                                ("#87CEEB", "Azul Claro"),
                                ("#4169E1", "Azul Royal"),
                            ],
                            "help_text": "Cor do círculo",
                        },
                    ),
                    6: (
                        "wagtail.blocks.TextBlock",
                        (),
                        {"help_text": "Descrição do step", "max_length": 300},
                    ),
                    7: (
                        "wagtail.blocks.ChoiceBlock",
                        [],
                        {
                            "choices": [
                                ("#2F4F4F", "Verde Escuro"),
                                ("#000000", "Preto"),
                                ("#4A4A4A", "Cinza Escuro"),
                                ("#696969", "Cinza Médio"),
                                ("#8B4513", "Marrom"),
                            ],
                            "help_text": "Cor do texto da descrição",
                        },
                    ),
                    8: (
                        "wagtail.blocks.StructBlock",
                        [
                            [
                                ("data", 3),
                                ("cor_data", 4),
                                ("cor_circulo", 5),
                                ("descricao", 6),
                                ("cor_descricao", 7),
                            ]
                        ],
                        {"icon": "date", "label": "Step do Cronograma"},
                    ),
                    9: (
                        "wagtail.blocks.StreamBlock",
                        [[("step", 8)]],
                        {
                            "help_text": "Adicione entre 2 e 10 steps no cronograma",
                            "max_num": 10,
                            "min_num": 2,
                        },
                    ),
                    10: (
                        "wagtail.blocks.StructBlock",
                        [
                            [
                                ("imagem_fundo", 0),
                                ("titulo", 1),
                                ("cor_titulo", 2),
                                ("steps", 9),
                            ]
                        ],
                        {},
                    ),
                },
            ),
        ),
    ]
